seo: 
  title: Ultimate Guide to CI/CD
  description: Find helpful tips — whether you're new to CI/CD or an advanced user — to develop and deliver software in a more agile, automated, and efficient manner.
  og_title: Ultimate Guide to CI/CD
  twitter_description: Find helpful tips — whether you're new to CI/CD or an advanced user — to develop and deliver software in a more agile, automated, and efficient manner.
  og_description: Find helpful tips — whether you're new to CI/CD or an advanced user — to develop and deliver software in a more agile, automated, and efficient manner.
  og_image: /nuxt-images/paid-search-lp/ci-cd-ebook-opengraph.png
  twitter_image: /nuxt-images/paid-search-lp/ci-cd-ebook-opengraph.png
content: 
  hero:
    default:
      class: purple
      background_image: 
        url: /nuxt-images/paid-search-lp/ultimate-guide-to-ci-cd-hero.svg
        alt: 'Ultimate Guide to CI/CD'
      heading: 'Ultimate Guide to CI/CD'
      text: Learn the fundamentals, best practices for security, how to integrate AI, and more.
      button:
        url: '#interest'
        dataGaName: access now
        text: Access now
        noIcon: true
      pill:
        type: Free Guide
        icon: 
          name: ebook
          variant: marketing
          alt: resource
  formSection:
    header: "CI/CD fundamentals to advanced strategies"
    pill:
      type: Free Guide
      icon: 
        name: ebook
        variant: marketing
        alt: resource
    description: >
      Continuous integration and continuous delivery (CI/CD) have revolutionized how software teams work together. Gone are the days of code integration headaches and repeated manual processes. CI/CD makes modern software development possible — fast, reliable, and automated.


      This guide explains modern CI/CD pipelines, from basic principles to best practices to advanced strategies. **Whether you're new to CI/CD or an advanced user, you'll find helpful tips in this comprehensive guide.**
    listTitle:  "In this guide, you'll learn:"
    list: 
      - text: What CI, CD, and CI/CD pipelines are
      - text: The benefits of CI/CD in modern software development
      - text: Best practices for implementation and management 
      - text: Why integrating SCM and CI/CD matters
      - text: How you can use AI for better efficiency and security
    form: 
      formId: 1002
      all_required: false
      hr: true
      form_header: Download your free guide
      header_config:
        text_align: left
        text_variant: heading4-bold
        text_tag: h4
      formDataLayer: resources
      submitted_message:
        header: Submission recieved!
        text: "We'll be in touch shortly."
      gated_asset: 
        link: https://learn.gitlab.com/ps-ci-cd/ebook-ultimate-guide-ci-cd
        utm_campaign: paid_search
  recognitionCards:
    darkMode: true
    cards:
      - text: 'GitLab is a Leader in the 2024 Gartner® Magic Quadrant™ for DevOps Platforms' 
        logo: https://images.ctfassets.net/xz1dnu24egyd/4ygrG5GR35viWCn3Myi6ME/a5598861e3a6066ac764ea4e69b20903/gartner-logo-white.svg
        logo_alt: ''
        link: 
          text: 'Read now'
          href: /gartner-magic-quadrant/
          data_ga_name: gartner-devops
          data_ga_location: body
      - text: 'The Total Economic Impact™ Of GitLab Ultimate: 3-year 483% return on investment' 
        logo: https://images.ctfassets.net/xz1dnu24egyd/2n4Q3FBiUVV3livuFOALFF/4e4f19eda8c2396d6420720192c339bd/forrester-logo-white.svg
        logo_alt: ''
        link: 
          text: 'Read now'
          href: /resources/study-forrester-tei-gitlab-ultimate/
          data_ga_name: forrester
          data_ga_location: body
      - text: 'GitLab named a Leader in the 2024 Gartner® Magic Quadrant™ for AI Code Assistants' 
        logo: https://images.ctfassets.net/xz1dnu24egyd/4ygrG5GR35viWCn3Myi6ME/a5598861e3a6066ac764ea4e69b20903/gartner-logo-white.svg
        logo_alt: ''
        link: 
          text: 'Read now'
          href: /gartner-mq-ai-code-assistants/
          data_ga_name: gartner-ai
          data_ga_location: body